""" Kips's Graph Convolutional Network (kGCN).

Ref: T. Kipf and M. Welling, "Semi-supervised classification with graph
convolutional networks", ICLR 2017.
"""
import torch
import torch.nn as nn
import torch.nn.functional as f
from dgl.nn.pytorch import GraphConv


class KGCN(nn.Module):
    """ Kipf's Graph Convolutional Network (kGCN).

    Ref: T. Kipf and M. Welling, "Semi-supervised classification with graph
    convolutional networks", ICLR 2017.

    loc_multiplier : This is a constant used to scale the locations generated by the GCN layer. This is an attempt to 
    scale the gradients going back to the location variables so that they move around more aggressively.
    
    """

    def __init__(self, feat_repr_dims, activation,dropout=0.5):
        """ Constructor.

        Args:
            feat_repr_dims (list): feature dimensions from input to output.
        """
        super().__init__()

        dims = zip(feat_repr_dims[:-1], feat_repr_dims[1:])
        self.depth = len(feat_repr_dims) - 1


        
        self.convs = nn.ModuleList([
            GraphConv(in_dim, out_dim)
            for indx, (in_dim, out_dim) in enumerate(dims)
        ])
        self.dropout = nn.Dropout(p=dropout)

        self.criterion = nn.CrossEntropyLoss()
        self.activation = activation
        
    def forward(self, graph, features):
        for indx, conv in enumerate(self.convs):
            features = self.dropout(features)
            features = conv(graph, features)
            if indx < self.depth-1:
                features = self.activation(features)

        logits = features
        return logits

    def loss(self, targets, predictions):
        return self.criterion(predictions, targets)

